# This file is part of caucase
# Copyright (C) 2017  Nexedi
#     Alain Takoudjou <alain.takoudjou@nexedi.com>
#     Vincent Pelletier <vincent@nexedi.com>
#
# caucase is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# caucase is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with caucase.  If not, see <http://www.gnu.org/licenses/>.

class Storage(object):
  def __init__(self, crt_life_time, loaded_crt_life_time):

  def getCAKeyPairList(self):
    """
    Return the chronologically sorted (oldest in [0], newest in [-1]) certificate authority
    key pairs.
    """

  def storeCAKeyPair(self, key_pair):
    """
    Store a certificate authority key pair.
    """

  def storeCertificateSigningRequest(self, csr):
    """
    Store acertificate signing request and generate a unique ID for it.
    """
    raise NoStorage('Too many pending CSRs')

  def deletePendingCertificateRequest(self, crt_id):
    raise NotFound('No pending CSR with id %r' % (crt_id, ))

  def getCertificateSigningRequest(self, crt_id):
    raise NotFound('No pending CSR with id %r' % (crt_id, ))

  def storeCertificate(self, crt_id, crt):
    """
    Store certificate as crt_id.
    """
    raise Found('CRT already exists')

  def getCertificate(self, crt_id):
    raise NotFound('No certficate with id %r' % (crt_id, ))
    # schedule certificate removal

  def revokeCertificate(self, serial, not_after_date):
    """
    Add serial to the list of revoked certificates.
    Associated certificate must expire at (or before) not_after_date, so
    revocation can be pruned.
    """
    # Store & make visible (ie, commit if applicable)
    # Flush cached CRL (forcing re-generation).

  def getCertificateRevocationList(self):
    # Fetch cached CRL (or re-generate and store if not cached).
    return crl

  def housekeep(self):
    """
    Remove outdated certificates (because they were retrieved long ago),
    ca certificates (because they exceeded their "not valid after" date),
    revocation of anway-expired certificates.
    """
